## ipu7-camera-hal 0~git202412040455.6ec7af8

=== CMakeLists.txt ===
#
#  Copyright (C) 2017-2022 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

cmake_minimum_required(VERSION 2.8)

project(libcamhal)

option(BUILD_CAMHAL_PLUGIN "Build libcamhal as plugins" OFF)
option(BUILD_CAMHAL_ADAPTOR "Build hal_adaptor as libcamhal" OFF)

#------------------------- Global settings -------------------------

#------------------------- folder settings -------------------------

# Source directories
set(SRC_ROOT_DIR        ${CMAKE_CURRENT_LIST_DIR}/src)

set(3A_DIR              ${SRC_ROOT_DIR}/3a)
set(CORE_DIR            ${SRC_ROOT_DIR}/core)
set(HAL_DIR             ${SRC_ROOT_DIR}/hal)
set(IIO_DIR             ${SRC_ROOT_DIR}/iio)
set(IUTILS_DIR          ${SRC_ROOT_DIR}/iutils)
set(METADATA_DIR        ${SRC_ROOT_DIR}/metadata)
set(PLATFORMDATA_DIR    ${SRC_ROOT_DIR}/platformdata)
set(SCHEDULER_DIR       ${SRC_ROOT_DIR}/scheduler)
set(V4L2_DIR            ${SRC_ROOT_DIR}/v4l2)
set(MODULES_DIR         ${CMAKE_CURRENT_LIST_DIR}/modules)
set(ALGOWRAPPER_DIR     ${MODULES_DIR}/algowrapper)
set(SANDBOXING_DIR      ${MODULES_DIR}/sandboxing)
set(IMAGE_PROCESS_DIR   ${SRC_ROOT_DIR}/image_process)

#AAL directories
if (CAL_BUILD)
    set(AAL_ROOT_DIR       ${CMAKE_CURRENT_LIST_DIR}/aal)
    set(JPEG_DIR           ${SRC_ROOT_DIR}/jpeg)
    set(MEMORY_DIR         ${MODULES_DIR}/memory)
endif() #CAL_BUILD

if (SUPPORT_LIVE_TUNING)
    #LiveTuning directories
    set(LIVE_TUNING_DIR         ${MODULES_DIR}/livetune)
endif() #SUPPORT_LIVE_TUNING

# CMake module directory
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

# Install directories
# CMAKE_INSTALL_PREFIX is defined when executing cmake and supposed to be ./out/libcamhal
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}" CACHE PATH "Target location for install command." FORCE)
endif()

#------------------------- compile and link options -------------------------

include(GNUInstallDirs)
# code coverage.
include(code-coverage)

message(STATUS "install prefix: " ${CMAKE_INSTALL_PREFIX})

set (CMAKE_CXX_STANDARD 11)
add_compile_options(
    -Wall
    -fstack-protector
    -fPIE
    -fPIC
    -DDCHECK_ALWAYS_ON
    -Wformat
    -Wformat-security
)
if (USE_STATIC_GRAPH)
    add_compile_options(-fpermissive -Wno-unused-variable -Wno-maybe-uninitialized)
endif()

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-faligned-new COMPILER_SUPPORTS_ALIGNED_NEW)
if (COMPILER_SUPPORTS_ALIGNED_NEW)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -faligned-new")
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package (Threads REQUIRED)

# check if _FORTIFY_SOURCE is default defined with -O
include(CheckFortifyLevel)
set(FORTIFY_SOURCE_VALUE)
check_fortify_source(FORTIFY_SOURCE_VALUE)
if(FORTIFY_SOURCE_VALUE)
    message(STATUS "compiler default _FORTIFY_SOURCE=${FORTIFY_SOURCE_VALUE}")
else()
    message(STATUS "_FORTIFY_SOURCE is not defined or could not be determined.")
    add_compile_options(-D_FORTIFY_SOURCE=2)
    message(STATUS "define _FORTIFY_SOURCE=2")
endif()

add_link_options(
    -fPIE
    -fPIC
    -Wformat
    -Wformat-security
    -Wl,-z,relro
    -Wl,-z,now
    -Wl,--no-as-needed
    -Wl,--no-undefined
)

# -fPIC in xos way
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

#------------------- common definitions, includes and link --------------------

add_definitions(-D__STDC_FORMAT_MACROS -DHAVE_PTHREADS -DHAVE_LINUX_OS -DHAVE_IA_TYPES -DHAVE_PRCTL)

include_directories(
    include
    include/api include/utils
    ${CMAKE_CURRENT_LIST_DIR}
    src
    src/v4l2 src/core src/metadata
    src/platformdata src/platformdata/gc
    src/3a src/3a/intel3a src/3a/external
    src/fd
    src/image_process
)

set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT} expat rt)

add_subdirectory(src)
add_subdirectory(modules)

if (USE_PG_LITE_PIPE)
    add_definitions(-DUSE_PG_LITE_PIPE)
endif() #USE_PG_LITE_PIPE

    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${IIO_SRCS})

if (SUPPORT_LIVE_TUNING)
    include_directories(modules/livetune)
    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${LIVE_TUNING_SRCS})
endif() #SUPPORT_LIVE_TUNING

if(FACE_DETECTION)
    add_definitions(-DFACE_DETECTION)
    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${FACE_DETECTION_SRCS})
    set(LIBCAMHAL_LINK_LIBS
        ${LIBCAMHAL_LINK_LIBS}
        pvl_eye_detection
        pvl_face_detection
        pvl_mouth_detection
        ${WORK_DIR_TMP}/src/fd/libface_detection.a
    )
endif() #FACE_DETECTION

if(ENABLE_SANDBOXING)
    find_package(LIBMOJO)
    find_package(LIBCAMERA_IPC)
    find_package(LIBCAB)
    add_definitions(-DENABLE_SANDBOXING)
    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${SANDBOXING_CLIENT_SRCS})
    include_directories(
        ${USR_INCLUDE_HEADER}/base-${BASEVER}
        ${LIBMOJO_INCLUDE_DIRS}
        ${LIBCAMERA_IPC_INCLUDE_DIRS}
        ${LIBCAB_INCLUDE_DIRS}
    )
    link_directories(
        ${CMAKE_PREFIX_PATH}
        ${LIBMOJO_LIBS}
        ${LIBCAMERA_IPC_LIBS}
        ${LIBCAB_LIBS}
    )
    set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${LIBCAB_LIBS} ${LIBMOJO_LIBS} ${LIBCAMERA_IPC_LIBS} ${CMAKE_PREFIX_PATH}/librt.a)
endif() #ENABLE_SANDBOXING

if (DYNAMIC_PAC_BUFFERS)
    add_definitions(-DMAX_PAC_BUFFERS=${DYNAMIC_PAC_BUFFERS})
else()
    add_definitions(-DMAX_PAC_BUFFERS=2U)
endif()


if (CAL_BUILD)
    message("Chrome enabled ")
    add_definitions(-DCAL_BUILD -DDUMP_IMAGE)
    if (SW_JPEG_ENCODE)
        add_definitions(-DSW_JPEG_ENCODE)
        include_directories(src/jpeg/sw)
    else ()
        include_directories(src/jpeg/chrome)
    endif()

    if (SW_POST_PROCESSING)
        include_directories(src/image_process/sw)
    else ()
        include_directories(src/image_process/chrome)
    endif()

    add_subdirectory(aal)

    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${MEMORY_SRCS} ${AAL_SRCS} ${JPEG_SRCS})
    include_directories(include include/api include/utils include/linux
        ${USR_INCLUDE_HEADER}/android/system/core/include/
        ${USR_INCLUDE_HEADER}/ia_imaging
        ${USR_INCLUDE_HEADER}/lib${IPU_VER}
        ${USR_INCLUDE_HEADER}/android/hardware/libhardware/include/
        aal aal/chrome src/iutils src/jpeg
        modules/memory modules/memory/chrome
    )
    find_package(LIBCAMERA_CLIENT)
    find_package(LIBCAMERA_COMMON)
    find_package(LIBCAMERA_METADATA)
    find_package(LIBCAMERA_V4L2_DEVICE)
    find_package(LIBSYNC)
    find_package(LIBCBM)

    include_directories(${LIBCAMERA_CLIENT_INCLUDE_DIRS} ${LIBCAMERA_COMMON_INCLUDE_DIRS}
                        ${LIBCAMERA_METADATA_INCLUDE_DIRS} ${LIBCAMERA_V4L2_DEVICE_INCLUDE_DIRS}
                        ${LIBSYNC_INCLUDE_DIRS}
                        ${LIBCBM_INCLUDE_DIRS}
    )
    link_directories(${CMAKE_PREFIX_PATH}
                     ${LIBCAMERA_CLIENT_LIBS}
                     ${LIBCAMERA_METADATA_LIBS}
                     ${LIBCAMERA_COMMON_LIBS}
                     ${LIBSYNC_LIBS}
                     ${LIBCBM_LIBS}
                     )

    set(LIBCAMHAL_LINK_LIBS
        ${LIBCAMHAL_LINK_LIBS}
        ${LIBCAMERA_CLIENT_LIBS}
        ${LIBCAMERA_COMMON_LIBS}
        ${LIBCAMERA_METADATA_LIBS}
        ${LIBCAMERA_V4L2_DEVICE_LIBS}
        ${LIBSYNC_LIBS}
        jpeg
        ${CMAKE_PREFIX_PATH}/libyuv.pic.a
        ${LIBCBM_LIBS}
        camera_v4l2_device
    )
endif() #CAL_BUILD

if (NOT CAL_BUILD)
    message("Linux build")
    add_definitions(-DSUPPORT_MULTI_PROCESS)
    add_definitions(-DLINUX_BUILD)
    include_directories(${MODULES_DIR}/v4l2)
endif()

set(LIBCAMHAL_SRCS
    ${LIBCAMHAL_SRCS}
    ${3A_SRCS}
    ${CORE_SRCS}
    ${HAL_SRCS}
    ${IPS_CTRL_SRCS}
    ${IUTILS_SRCS}
    ${METADATA_SRCS}
    ${PLATFORMDATA_SRCS}
    ${SCHEDULER_SRCS}
    ${V4L2_SRCS}
    ${ALGOWRAPPER_SRCS}
    ${IMAGE_PROCESS_SRCS}
    )

# #------------------------- Target settings -------------------------

if (NOT IPU_VERSIONS)
    set(IPU_VERSIONS ${IPU_VER})
endif()

if (BUILD_CAMHAL_ADAPTOR)
    add_subdirectory(src/hal/hal_adaptor)
    if (NOT BUILD_CAMHAL_PLUGIN)
        message(NOTICE "Will not build libcamhal plugins")
        set(IPU_VERSIONS "")
    endif()
endif()

# Add different targets according to array IPU_VERSIONS
foreach(IPU_VER ${IPU_VERSIONS})

if (BUILD_CAMHAL_PLUGIN)
    set(TARGET_SUFFIX "-${IPU_VER}")
endif()

set(TARGET_INCLUDE "")
set(TARGET_DEFINITIONS "")
set(TARGET_SRCS "")
set(TARGET_LINK_LIBS "")

if (IPU_VER MATCHES "ipu6")
    message(STATUS "add definition -DIPU_SYSVER_IPU6 for ${IPU_VER}")
    set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DIPU_SYSVER_IPU6)
    if (IPU_VER STREQUAL "ipu6sepla")
        message(STATUS "add definition -DIPU_SYSVER_ipu6v3 for ${IPU_VER}")
        set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DIPU_SYSVER_ipu6v3)
    elseif (IPU_VER STREQUAL "ipu6ep")
        message(STATUS "add definition -DIPU_SYSVER_ipu6v5 for ${IPU_VER}")
        set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DIPU_SYSVER_ipu6v5)
    elseif (IPU_VER STREQUAL "ipu6epmtl")
        message(STATUS "add definition -DIPU_SYSVER_ipu6v6 for ${IPU_VER}")
        set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DIPU_SYSVER_ipu6v6)
    endif()
    set(TARGET_INCLUDE ${TARGET_INCLUDE} src/core/psysprocessor)
elseif (IPU_VER MATCHES "ipu7.*")
    set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DSTATIC_GRAPH_USE_IA_AIC_TYPES -DPAC_ENABLE)
    set(TARGET_INCLUDE
        ${TARGET_INCLUDE}
        src/core/processingUnit
        src/scheduler
        src/jpeg
        src/iutils
    )
    set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} jsoncpp)
    if (IPU_VER STREQUAL "ipu7x")
        message(STATUS "add definition -DIPU_SYSVER_ipu7 for ${IPU_VER}")
        set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DIPU_SYSVER_ipu7 -DGRC_IPU7X)
        set(PRODUCTION_NAME "lnl")
        set(STATIC_GRAPH_IPU_PREFIXS "Ipu7x")
    elseif (IPU_VER STREQUAL "ipu75xa")
        message(STATUS "add definition -DIPU_SYSVER_ipu75 for ipu75xa")
        set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} -DIPU_SYSVER_ipu75 -DGRC_IPU75XA)
        set(PRODUCTION_NAME "ptl")
        set(STATIC_GRAPH_IPU_PREFIXS "Ipu75xa")
    endif()
endif()

if (NOT CAL_BUILD)
    set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} "-DCAMERA_DEFAULT_CFG_PATH=\"${CMAKE_INSTALL_FULL_SYSCONFDIR}/camera/${IPU_VER}/\"")
endif()

# Link libraries, the building will be interrupted if libs/includes not found
    # Link ia_imaging
    find_package(IA_IMAGING)
    set(TARGET_INCLUDE ${TARGET_INCLUDE} ${IA_IMAGING${TARGET_SUFFIX}_INCLUDE_DIRS})
    set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${IA_IMAGING${TARGET_SUFFIX}_LIBS})

    if(USE_PG_LITE_PIPE)
        find_package(LIBGCSS)
        set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBGCSS${TARGET_SUFFIX}_INCLUDE_DIRS})
        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBGCSS${TARGET_SUFFIX}_LIBS})
        # Include libipu(4) headers
        find_package(LIBIPU)
        set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBIPU${TARGET_SUFFIX}_INCLUDE_DIRS})
        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIPU${TARGET_SUFFIX}_LIBS})
    elseif (NOT USE_STATIC_GRAPH)
        # Link libiacss
        find_package(LIBIACSS)
        set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBIACSS${TARGET_SUFFIX}_INCLUDE_DIRS})
        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIACSS${TARGET_SUFFIX}_LIBS})
    endif()

if (USE_STATIC_GRAPH)
    set(TARGET_INCLUDE ${TARGET_INCLUDE} modules/ipu_desc modules/ipu_desc/${PRODUCTION_NAME})
    if (USE_STATIC_GRAPH_AUTOGEN)

=== modules/CMakeLists.txt ===
#
#  Copyright (C) 2019-2020 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

if (CAL_BUILD)
    add_subdirectory(memory)
endif() #CAL_BUILD

    if (ENABLE_SANDBOXING)
        add_subdirectory(sandboxing)
    else()
        add_subdirectory(algowrapper)
    endif() #ENABLE_SANDBOXING

if (SUPPORT_LIVE_TUNING)
    add_subdirectory(livetune)
endif() #SUPPORT_LIVE_TUNING

=== src/CMakeLists.txt ===
#
#  Copyright (C) 2018-2022 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

add_subdirectory(3a)
add_subdirectory(core)
add_subdirectory(hal)
add_subdirectory(iutils)
add_subdirectory(metadata)
add_subdirectory(platformdata)
add_subdirectory(v4l2)
add_subdirectory(scheduler)
add_subdirectory(image_process)
if (CAL_BUILD)
    add_subdirectory(jpeg)
endif() #CAL_BUILD
if(FACE_DETECTION)
    add_subdirectory(fd)
endif() #FACE_DETECTION

=== modules/memory/CMakeLists.txt ===
#
#  Copyright (C) 2019-2024 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#
#

set(MEMORY_SRCS
    ${MEMORY_DIR}/chrome/Camera3Buffer.cpp
    ${MEMORY_DIR}/chrome/BufferAllocator.cpp
    CACHE INTERNAL "Memory sources"
    )

=== src/3a/CMakeLists.txt ===
#
#  Copyright (C) 2017-2021 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set(3A_SRCS
    ${3A_DIR}/I3AControlFactory.cpp
    CACHE INTERNAL "3A sources"
    )

    set(3A_SRCS
        ${3A_SRCS}
        ${3A_DIR}/AiqUtils.cpp
        ${3A_DIR}/intel3a/Intel3AParameter.cpp
        ${3A_DIR}/AiqResult.cpp
        ${3A_DIR}/AiqResultStorage.cpp
        ${3A_DIR}/SensorManager.cpp
        ${3A_DIR}/LensManager.cpp
        ${3A_DIR}/AiqCore.cpp
        ${3A_DIR}/AiqEngine.cpp
        ${3A_DIR}/AiqSetting.cpp
        ${3A_DIR}/AiqUnit.cpp
        ${3A_DIR}/MakerNote.cpp
        CACHE INTERNAL "3A sources"
        )

=== src/core/CMakeLists.txt ===
#
#  Copyright (C) 2017-2024 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set(CORE_SRCS
    ${CORE_DIR}/BufferQueue.cpp
    ${CORE_DIR}/CameraBuffer.cpp
    ${CORE_DIR}/CameraEvent.cpp
    ${CORE_DIR}/LensHw.cpp
    ${CORE_DIR}/SensorHwCtrl.cpp
    ${CORE_DIR}/SofSource.cpp
    CACHE INTERNAL "core sources"
    )

# IPU7_SOURCE_FILE_S
set(CORE_SRCS
    ${CORE_SRCS}
    ${CORE_DIR}/CameraBufferPool.cpp
    ${CORE_DIR}/CameraDevice.cpp
    ${CORE_DIR}/CameraContext.cpp
    ${CORE_DIR}/CameraStream.cpp
    ${CORE_DIR}/CaptureUnit.cpp
    ${CORE_DIR}/DeviceBase.cpp
    ${CORE_DIR}/IProcessingUnitFactory.cpp
    ${CORE_DIR}/ProcessingUnit.cpp
    ${CORE_DIR}/RequestThread.cpp
    ${CORE_DIR}/PSysDevice.cpp
    CACHE INTERNAL "core sources"
    )
if (CAL_BUILD)
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/SwPostProcessUnit.cpp
        CACHE INTERNAL "core sources"
        )
endif() #CAL_BUILD
# IPU7_SOURCE_FILE_E

# FRAME_SYNC_S
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/SyncManager.cpp
        CACHE INTERNAL "core sources"
        )
# FRAME_SYNC_E

# CSI_META_S
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/CsiMetaDevice.cpp
        CACHE INTERNAL "core sources"
        )
# CSI_META_E

# FILE_SOURCE_S
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/FileSource.cpp
        CACHE INTERNAL "core sources"
        )
# FILE_SOURCE_E

if (NOT CAL_BUILD)
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/SwImageProcessor.cpp
        CACHE INTERNAL "core sources"
        )
endif()
    set(CORE_SRCS
        ${CORE_SRCS}
        CACHE INTERNAL "core sources"
        )

# IPU_PROCESSING_S
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/ProcessingUnit.cpp
        ${CORE_DIR}/processingUnit/IPipeManagerFactory.cpp
        CACHE INTERNAL "core sources"
    )

# IPU7_SOURCE_FILE_S
    set(CORE_SRCS
        ${CORE_SRCS}
        ${CORE_DIR}/IpuPacAdaptor.cpp
        ${CORE_DIR}/processingUnit/PipeManager.cpp
        ${CORE_DIR}/processingUnit/PipeLine.cpp
        ${CORE_DIR}/processingUnit/CBStage.cpp
        CACHE INTERNAL "core sources"
    )
# IPU7_SOURCE_FILE_E

# IPU_PROCESSING_E

=== src/hal/CMakeLists.txt ===
#
#  Copyright (C) 2017-2022 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set(HAL_SRCS
    ${HAL_DIR}/CameraHal.cpp
    ${HAL_DIR}/ICamera.cpp
    ${HAL_DIR}/ParameterConvert.cpp
    CACHE INTERNAL "hal sources"
    )

=== src/image_process/CMakeLists.txt ===
#
#  Copyright (C) 2019-2022 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

if (CAL_BUILD)
set(IMAGE_PROCESS_SRCS
    ${IMAGE_PROCESS_DIR}/PostProcessorBase.cpp
    ${IMAGE_PROCESS_DIR}/PostProcessorCore.cpp
    CACHE INTERNAL "image_process sources"
    )
if (SW_POST_PROCESSING)
    set(IMAGE_PROCESS_SRCS
        ${IMAGE_PROCESS_SRCS}
        ${IMAGE_PROCESS_DIR}/sw/SWPostProcessor.cpp
        ${IMAGE_PROCESS_DIR}/sw/ImageConverter.cpp
        ${IMAGE_PROCESS_DIR}/sw/ImageScalerCore.cpp
        CACHE INTERNAL "image_process sources"
       )
else()
    set(IMAGE_PROCESS_SRCS
        ${IMAGE_PROCESS_SRCS}
        ${IMAGE_PROCESS_DIR}/chrome/ImageProcessorCore.cpp
        CACHE INTERNAL "image_process sources"
        )
endif() #SW_POST_PROCESSING
endif() #CAL_BUILD

=== src/iutils/CMakeLists.txt ===
#
#  Copyright (C) 2017-2022 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set(IUTILS_SRCS
    ${IUTILS_DIR}/CameraLog.cpp
    ${IUTILS_DIR}/LogSink.cpp
    ${IUTILS_DIR}/ModuleTags.cpp
    ${IUTILS_DIR}/CameraDump.cpp
    ${IUTILS_DIR}/Trace.cpp
    ${IUTILS_DIR}/ScopedAtrace.cpp
    ${IUTILS_DIR}/Thread.cpp
    ${IUTILS_DIR}/Utils.cpp
# SUPPORT_MULTI_PROCESS_S
    ${IUTILS_DIR}/CameraShm.cpp
# SUPPORT_MULTI_PROCESS_E
    CACHE INTERNAL "iutils sources"
    )

if (NOT CAL_BUILD)
    set(IUTILS_SRCS
        ${IUTILS_SRCS}
        ${IUTILS_DIR}/SwImageConverter.cpp
        CACHE INTERNAL "iutils sources"
        )
endif()

=== src/metadata/CMakeLists.txt ===
#
#  Copyright (C) 2017-2022 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set(METADATA_SRCS
    ${METADATA_DIR}/icamera_metadata_base.cpp
    ${METADATA_DIR}/CameraMetadata.cpp
    ${METADATA_DIR}/Parameters.cpp
    ${METADATA_DIR}/ParameterHelper.cpp
    CACHE INTERNAL "metadata sources"
    )

    set(METADATA_SRCS
        ${METADATA_SRCS}
        CACHE INTERNAL "metadata sources"
        )

=== src/platformdata/CMakeLists.txt ===
#
#  Copyright (C) 2017-2024 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set(PLATFORMDATA_SRCS
    ${PLATFORMDATA_DIR}/PlatformData.cpp
    CACHE INTERNAL "platformdata sources"
   )

# IPU7_SOURCE_FILE_S
set(PLATFORMDATA_SRCS ${PLATFORMDATA_SRCS}
    ${PLATFORMDATA_DIR}/CameraParserInvoker.cpp
    ${PLATFORMDATA_DIR}/CameraSensorsParser.cpp
    ${PLATFORMDATA_DIR}/JsonCommonParser.cpp
    ${PLATFORMDATA_DIR}/JsonParserBase.cpp
    CACHE INTERNAL "platformdata sources"
)
# IPU7_SOURCE_FILE_E

    set(PLATFORMDATA_SRCS
        ${PLATFORMDATA_SRCS}
        ${PLATFORMDATA_DIR}/AiqInitData.cpp
        ${PLATFORMDATA_DIR}/gc/GraphUtils.cpp
        ${PLATFORMDATA_DIR}/gc/GraphConfigManager.cpp
        ${PLATFORMDATA_DIR}/gc/GraphConfig.cpp
        CACHE INTERNAL "platformdata sources"
        )

=== src/scheduler/CMakeLists.txt ===
#
#Copyright(C) 2022 Intel Corporation
#
#Licensed under the Apache License, Version 2.0(the "License");
#you may not use this file except in compliance with the License.
#You may obtain a copy of the License at
#
#http:  // www.apache.org/licenses/LICENSE-2.0
#
#Unless required by applicable law or agreed to in writing, software
#distributed under the License is distributed on an "AS IS" BASIS,
#WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#See the License for the specific language governing permissions and
#limitations under the License.
#

set(SCHEDULER_SRCS
    ${SCHEDULER_DIR}/CameraScheduler.cpp
    ${SCHEDULER_DIR}/CameraSchedulerPolicy.cpp
    CACHE INTERNAL "scheduler sources")

=== debian/changelog ===
ipu7-camera-hal (0~git202412040455.6ec7af8-1~ubuntu24.04.1) noble; urgency=medium

  [ Shih-Yuan Lee (FourDollars) ]
  * Initial release.

  [ Commercial Engineering ]
  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Wed, 04 Dec 2024 05:13:11 +0000

=== debian/control ===
Source: ipu7-camera-hal
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 libexpat-dev,
 libipu7x-dev (>= 0~git202409300310.ef8ead3~),
 libipu75xa-dev (>= 0~git202409300310.ef8ead3~),
 libjsoncpp-dev,
 pkg-config,
 dh-modaliases,
Standards-Version: 4.5.0
Maintainer: Commercial Engineering <commercial-engineering@canonical.com>
Vcs-Browser: https://github.com/intel/ipu7-camera-hal
Vcs-Git: https://github.com/intel/ipu7-camera-hal.git

Package: libcamhal-ipu75xa-common
Architecture: all
Depends:
 ${misc:Depends},
Description: HAL library for MIPI camera through Intel IPU7 PTL - common files
 This package contains default camera settings on Intel Panther Lake platform.

Package: libcamhal-ipu7x-common
Architecture: all
Depends:
 ${misc:Depends},
Description: HAL library for MIPI camera through Intel IPU7 LNL - common files
 This package contains default camera settings on Intel Lunar Lake platform.

Package: libcamhal-ipu7-common
Architecture: all
Depends:
 ${misc:Depends},
 libcamhal-ipu7x-common (= ${binary:Version}),
Description: Transitional package for libcamhal-ipu7x-common
 This is a transitional package for libcamhal-ipu7x-common, and can be
 safely removed after the installation is complete.

Package: libcamhal-ipu75xa0
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal-ipu75xa-common (= ${binary:Version}),
 libcamhal0 (>= 0~git202408150943.6991325~~),
XB-Modaliases: ${modaliases}
Description: HAL library for MIPI camera through Intel IPU7 PTL
 This package contains the main runtime library on Intel Panther Lake platform.

Package: libcamhal-ipu7x0
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal-ipu7x-common (= ${binary:Version}),
 libcamhal0 (>= 0~git202408150943.6991325~~),
XB-Modaliases: ${modaliases}
Description: HAL library for MIPI camera through Intel IPU7 LNL
 This package contains the main runtime library on Intel Lunar Lake platform.

Package: libcamhal-ipu7-0
Architecture: all
Depends:
 ${misc:Depends},
 libcamhal-ipu7x0 (= ${binary:Version}),
Description: Transitional package for libcamhal-ipu7x0
 This is a transitional package for libcamhal-ipu7x0, and can be
 safely removed after the installation is complete.

Package: libcamhal-ipu75xa-dev
Architecture: any
Depends:
 ${misc:Depends},
 libcamhal-ipu75xa-0 (= ${binary:Version}),
Description: HAL library for MIPI camera through Intel IPU7 PTL - development kit
 This package contains development files for libcamhal-ipu75xa on Intel Panther
 Lake platform.

Package: libcamhal-ipu7x-dev
Architecture: any
Depends:
 ${misc:Depends},
 libcamhal-ipu7x-0 (= ${binary:Version}),
Description: HAL library for MIPI camera through Intel IPU7 LNL - development kit
 This package contains development files for libcamhal-ipu7x on Intel Lunar
 Lake platform.

Package: libcamhal-ipu7-dev
Architecture: all
Depends:
 ${misc:Depends},
 libcamhal-ipu7x-dev (= ${binary:Version}),
Description: Transitional package for libcamhal-ipu7x-dev
 This is a transitional package for libcamhal-ipu7x-dev, and can be
 safely removed after the installation is complete.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

configure_args = \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_LIBDIR=lib \
	-DBUILD_CAMHAL_ADAPTOR=OFF \
	-DBUILD_CAMHAL_PLUGIN=ON \
	-DUSE_STATIC_GRAPH=ON \
	-DUSE_STATIC_GRAPH_AUTOGEN=ON \
	$(empty)

targets = ipu7x ipu75xa

%:
	dh $@ --with modaliases

override_dh_auto_configure:
	for ipu_ver in $(targets); do \
	  dh_auto_configure --builddirectory=build/$${ipu_ver} -- \
	      -DIPU_VERSIONS=$${ipu_ver} $(configure_args); \
	done

override_dh_auto_build:
	for ipu_ver in $(targets); do \
	  dh_auto_build --builddirectory=build/$${ipu_ver}; \
	done

override_dh_auto_install:
	find config/linux -name *.bin -or -name *.aiqb | sed 's,config/linux,debian,g'| sed 's,ipu7x,ipu7x/etc/camera/ipu7x,g' | sed 's,ipu75xa,ipu75xa/etc/camera/ipu75xa,g' | sort > debian/source/include-binaries
	for ipu_ver in $(targets); do \
	  sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
	      debian/libcamhal-$${ipu_ver}0.install.in > debian/libcamhal-$${ipu_ver}0.install; \
	  sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
	      debian/libcamhal-$${ipu_ver}-dev.install.in > debian/libcamhal-$${ipu_ver}-dev.install; \
	  dh_auto_install --builddirectory=build/$${ipu_ver} --destdir=debian/$${ipu_ver}; \
	done

override_dh_auto_clean:
	for ipu_ver in $(targets); do \
	  dh_auto_clean --builddirectory=build/$${ipu_ver}; \
	done
	rm -rf debian/tmp

## ipu7-camera-hal 0~git202501150539.431ff3f

=== CMakeLists.txt ===
--- 
+++ 
@@ -42,13 +42,6 @@
 set(SANDBOXING_DIR      ${MODULES_DIR}/sandboxing)
 set(IMAGE_PROCESS_DIR   ${SRC_ROOT_DIR}/image_process)
 
-#AAL directories
-if (CAL_BUILD)
-    set(AAL_ROOT_DIR       ${CMAKE_CURRENT_LIST_DIR}/aal)
-    set(JPEG_DIR           ${SRC_ROOT_DIR}/jpeg)
-    set(MEMORY_DIR         ${MODULES_DIR}/memory)
-endif() #CAL_BUILD
-
 if (SUPPORT_LIVE_TUNING)
     #LiveTuning directories
     set(LIVE_TUNING_DIR         ${MODULES_DIR}/livetune)
@@ -192,72 +185,16 @@
 endif()
 
 
-if (CAL_BUILD)
-    message("Chrome enabled ")
-    add_definitions(-DCAL_BUILD -DDUMP_IMAGE)
-    if (SW_JPEG_ENCODE)
-        add_definitions(-DSW_JPEG_ENCODE)
-        include_directories(src/jpeg/sw)
-    else ()
-        include_directories(src/jpeg/chrome)
-    endif()
-
-    if (SW_POST_PROCESSING)
-        include_directories(src/image_process/sw)
-    else ()
-        include_directories(src/image_process/chrome)
-    endif()
-
-    add_subdirectory(aal)
-
-    set(LIBCAMHAL_SRCS ${LIBCAMHAL_SRCS} ${MEMORY_SRCS} ${AAL_SRCS} ${JPEG_SRCS})
-    include_directories(include include/api include/utils include/linux
-        ${USR_INCLUDE_HEADER}/android/system/core/include/
-        ${USR_INCLUDE_HEADER}/ia_imaging
-        ${USR_INCLUDE_HEADER}/lib${IPU_VER}
-        ${USR_INCLUDE_HEADER}/android/hardware/libhardware/include/
-        aal aal/chrome src/iutils src/jpeg
-        modules/memory modules/memory/chrome
-    )
-    find_package(LIBCAMERA_CLIENT)
-    find_package(LIBCAMERA_COMMON)
-    find_package(LIBCAMERA_METADATA)
-    find_package(LIBCAMERA_V4L2_DEVICE)
-    find_package(LIBSYNC)
-    find_package(LIBCBM)
-
-    include_directories(${LIBCAMERA_CLIENT_INCLUDE_DIRS} ${LIBCAMERA_COMMON_INCLUDE_DIRS}
-                        ${LIBCAMERA_METADATA_INCLUDE_DIRS} ${LIBCAMERA_V4L2_DEVICE_INCLUDE_DIRS}
-                        ${LIBSYNC_INCLUDE_DIRS}
-                        ${LIBCBM_INCLUDE_DIRS}
-    )
-    link_directories(${CMAKE_PREFIX_PATH}
-                     ${LIBCAMERA_CLIENT_LIBS}
-                     ${LIBCAMERA_METADATA_LIBS}
-                     ${LIBCAMERA_COMMON_LIBS}
-                     ${LIBSYNC_LIBS}
-                     ${LIBCBM_LIBS}
-                     )
-
-    set(LIBCAMHAL_LINK_LIBS
-        ${LIBCAMHAL_LINK_LIBS}
-        ${LIBCAMERA_CLIENT_LIBS}
-        ${LIBCAMERA_COMMON_LIBS}
-        ${LIBCAMERA_METADATA_LIBS}
-        ${LIBCAMERA_V4L2_DEVICE_LIBS}
-        ${LIBSYNC_LIBS}
-        jpeg
-        ${CMAKE_PREFIX_PATH}/libyuv.pic.a
-        ${LIBCBM_LIBS}
-        camera_v4l2_device
-    )
-endif() #CAL_BUILD
-
-if (NOT CAL_BUILD)
-    message("Linux build")
-    add_definitions(-DSUPPORT_MULTI_PROCESS)
-    add_definitions(-DLINUX_BUILD)
-    include_directories(${MODULES_DIR}/v4l2)
+message("Linux build")
+add_definitions(-DSUPPORT_MULTI_PROCESS)
+add_definitions(-DLINUX_BUILD)
+include_directories(${MODULES_DIR}/v4l2)
+find_package(LIBDRM)
+if(LIBDRM_FOUND AND ("${LIBDRM_VERSION}" VERSION_GREATER_EQUAL 2.4.114))
+    include_directories(${LIBDRM_INCLUDE_DIRS})
+    link_directories(${LIBDRM_LIBRARY_DIRS})
+    set(LIBCAMHAL_LINK_LIBS ${LIBCAMHAL_LINK_LIBS} ${LIBDRM_LIBRARIES})
+    add_definitions(-DLIBDRM_SUPPORT_MMAP_OFFSET)
 endif()
 
 set(LIBCAMHAL_SRCS
@@ -338,31 +275,67 @@
     endif()
 endif()
 
-if (NOT CAL_BUILD)
-    set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} "-DCAMERA_DEFAULT_CFG_PATH=\"${CMAKE_INSTALL_FULL_SYSCONFDIR}/camera/${IPU_VER}/\"")
-endif()
+set(TARGET_DEFINITIONS ${TARGET_DEFINITIONS} "-DCAMERA_DEFAULT_CFG_PATH=\"${CMAKE_INSTALL_FULL_SYSCONFDIR}/camera/${IPU_VER}/\"")
 
 # Link libraries, the building will be interrupted if libs/includes not found
     # Link ia_imaging
     find_package(IA_IMAGING)
     set(TARGET_INCLUDE ${TARGET_INCLUDE} ${IA_IMAGING${TARGET_SUFFIX}_INCLUDE_DIRS})
-    set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${IA_IMAGING${TARGET_SUFFIX}_LIBS})
+    set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${IA_IMAGING${TARGET_SUFFIX}_LIBRARIES})
+    link_directories(${IA_IMAGING${TARGET_SUFFIX}_LIBRARY_DIRS})
 
     if(USE_PG_LITE_PIPE)
         find_package(LIBGCSS)
         set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBGCSS${TARGET_SUFFIX}_INCLUDE_DIRS})
-        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBGCSS${TARGET_SUFFIX}_LIBS})
+        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBGCSS${TARGET_SUFFIX}_LIBRARIES})
+        link_directories(${LIBGCSS${TARGET_SUFFIX}_LIBRARY_DIRS})
         # Include libipu(4) headers
         find_package(LIBIPU)
         set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBIPU${TARGET_SUFFIX}_INCLUDE_DIRS})
-        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIPU${TARGET_SUFFIX}_LIBS})
+        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIPU${TARGET_SUFFIX}_LIBRARIES})
+        link_directories(${LIBIPU${TARGET_SUFFIX}_LIBRARY_DIRS})
     elseif (NOT USE_STATIC_GRAPH)
         # Link libiacss
         find_package(LIBIACSS)
         set(TARGET_INCLUDE ${TARGET_INCLUDE} ${LIBIACSS${TARGET_SUFFIX}_INCLUDE_DIRS})
-        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIACSS${TARGET_SUFFIX}_LIBS})
+        set(TARGET_LINK_LIBS ${TARGET_LINK_LIBS} ${LIBIACSS${TARGET_SUFFIX}_LIBRARIES})
+        link_directories(${LIBIACSS${TARGET_SUFFIX}_LIBRARY_DIRS})
     endif()
 
 if (USE_STATIC_GRAPH)
     set(TARGET_INCLUDE ${TARGET_INCLUDE} modules/ipu_desc modules/ipu_desc/${PRODUCTION_NAME})
     if (USE_STATIC_GRAPH_AUTOGEN)
+        message(STATUS "Use auto generated static graph code, prefix: ${STATIC_GRAPH_IPU_PREFIXS}")
+        set(TARGET_SRCS ${TARGET_SRCS}
+            ${MODULES_DIR}/ipu_desc/${PRODUCTION_NAME}/CBLayoutUtils.cpp
+            ${MODULES_DIR}/ipu_desc/${PRODUCTION_NAME}/GraphResolutionConfigurator.cpp
+            ${MODULES_DIR}/ipu_desc/${PRODUCTION_NAME}/${STATIC_GRAPH_IPU_PREFIXS}GraphResolutionConfiguratorAutogen.cpp
+            ${MODULES_DIR}/ipu_desc/${PRODUCTION_NAME}/${STATIC_GRAPH_IPU_PREFIXS}TerminalDescriptorAutogen.cpp
+            ${MODULES_DIR}/ipu_desc/${PRODUCTION_NAME}/${STATIC_GRAPH_IPU_PREFIXS}StaticGraphAutogen.cpp
+            ${MODULES_DIR}/ipu_desc/${PRODUCTION_NAME}/${STATIC_GRAPH_IPU_PREFIXS}StaticGraphReaderAutogen.cpp
+            )
+    else ()
+        message(STATUS "Use ${PRODUCTION_NAME} static graph code")
+        set(TARGET_SRCS ${TARGET_SRCS}
+            ${MODULES_DIR}/ipu_desc/${PRODUCTION_NAME}/CBLayoutUtils.cpp
+            ${MODULES_DIR}/ipu_desc/${PRODUCTION_NAME}/TerminalDescriptorAutogen.cpp
+            ${MODULES_DIR}/ipu_desc/${PRODUCTION_NAME}/StaticGraphAutogen.cpp
+            ${MODULES_DIR}/ipu_desc/${PRODUCTION_NAME}/StaticGraphReaderAutogen.cpp
+            )
+    endif () # STATIC_GRAPH_IPU_PREFIXS
+endif() # USE_STATIC_GRAPH
+
+#--------------------------- Add libcamhal target  ---------------------------
+
+if (BUILD_CAMHAL_PLUGIN)
+    set(CAMHAL_TARGET camhal${IPU_VER})
+    set(CAMHAL_STATIC_TARGET camhal${IPU_VER}_static)
+else()
+    set(CAMHAL_TARGET camhal)
+    set(CAMHAL_STATIC_TARGET camhal_static)
+endif()
+
+# Add libcamhal using the specified sources
+add_library(${CAMHAL_STATIC_TARGET} STATIC ${LIBCAMHAL_SRCS} ${TARGET_SRCS})
+
+if (${CMAKE_VERSION} VERSION_LESS 3.11)

=== modules/CMakeLists.txt ===
--- 
+++ 
@@ -14,10 +14,6 @@
 #  limitations under the License.
 #
 
-if (CAL_BUILD)
-    add_subdirectory(memory)
-endif() #CAL_BUILD
-
     if (ENABLE_SANDBOXING)
         add_subdirectory(sandboxing)
     else()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -22,10 +22,6 @@
 add_subdirectory(platformdata)
 add_subdirectory(v4l2)
 add_subdirectory(scheduler)
-add_subdirectory(image_process)
-if (CAL_BUILD)
-    add_subdirectory(jpeg)
-endif() #CAL_BUILD
 if(FACE_DETECTION)
     add_subdirectory(fd)
 endif() #FACE_DETECTION

=== modules/algowrapper/CMakeLists.txt ===
#
#  Copyright (C) 2019-2021 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#
#

set(ALGOWRAPPER_SRCS
    ${ALGOWRAPPER_DIR}/IntelCca.cpp
    CACHE INTERNAL "algo wrapper sources"
    )

if (NOT USE_STATIC_GRAPH)
set(ALGOWRAPPER_SRCS ${ALGOWRAPPER_SRCS}
    ${ALGOWRAPPER_DIR}/graph/GraphConfigImpl.cpp
    ${ALGOWRAPPER_DIR}/graph/GraphConfigPipe.cpp
    CACHE INTERNAL "algo wrapper sources"
    )
endif()

if (USE_PG_LITE_PIPE)
    set(ALGOWRAPPER_SRCS
        ${ALGOWRAPPER_SRCS}
        ${ALGOWRAPPER_DIR}/IntelPGParam.cpp
        CACHE INTERNAL "algo wrapper sources" )
endif() #USE_PG_LITE_PIPE

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -39,13 +39,6 @@
     ${CORE_DIR}/PSysDevice.cpp
     CACHE INTERNAL "core sources"
     )
-if (CAL_BUILD)
-    set(CORE_SRCS
-        ${CORE_SRCS}
-        ${CORE_DIR}/SwPostProcessUnit.cpp
-        CACHE INTERNAL "core sources"
-        )
-endif() #CAL_BUILD
 # IPU7_SOURCE_FILE_E
 
 # FRAME_SYNC_S
@@ -72,13 +65,11 @@
         )
 # FILE_SOURCE_E
 
-if (NOT CAL_BUILD)
-    set(CORE_SRCS
-        ${CORE_SRCS}
-        ${CORE_DIR}/SwImageProcessor.cpp
-        CACHE INTERNAL "core sources"
-        )
-endif()
+set(CORE_SRCS
+    ${CORE_SRCS}
+    ${CORE_DIR}/SwImageProcessor.cpp
+    CACHE INTERNAL "core sources"
+    )
     set(CORE_SRCS
         ${CORE_SRCS}
         CACHE INTERNAL "core sources"

=== src/fd/CMakeLists.txt ===
#
#  Copyright (C) 2019-2020 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#
#

# Use -DFACE_DETECTION to enable the face detection feature
if (NOT ENABLE_SANDBOXING)
    set(FACE_DETECTION_SRCS
        ${SRC_ROOT_DIR}/fd/FaceDetection.cpp
        ${ALGOWRAPPER_DIR}/IntelFaceDetection.cpp
        CACHE INTERNAL "Face detect sources"
        )
#---------------------------- include the header ----------------------------
    include_directories(${USR_INCLUDE_HEADER}/ia_imaging
                        ${ALGOWRAPPER_DIR}/IntelFaceDetection.h
                        ${IUTILS_DIR}
                        include/utils)
#---------------------------- static library ----------------------------
    add_library(face_detection STATIC ${FACE_DETECTION_SRCS})
else ()
    set(FACE_DETECTION_SRCS
        ${SRC_ROOT_DIR}/fd/FaceDetection.cpp
        CACHE INTERNAL "Face detect sources"
        )
endif()

include_directories(${MODULES_DIR}/v4l2)

=== src/iutils/CMakeLists.txt ===
--- 
+++ 
@@ -29,10 +29,8 @@
     CACHE INTERNAL "iutils sources"
     )
 
-if (NOT CAL_BUILD)
-    set(IUTILS_SRCS
-        ${IUTILS_SRCS}
-        ${IUTILS_DIR}/SwImageConverter.cpp
-        CACHE INTERNAL "iutils sources"
-        )
-endif()
+set(IUTILS_SRCS
+    ${IUTILS_SRCS}
+    ${IUTILS_DIR}/SwImageConverter.cpp
+    CACHE INTERNAL "iutils sources"
+    )

=== src/v4l2/CMakeLists.txt ===
#
#  Copyright (C) 2017,2020 Intel Corporation
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

set (V4L2_SRCS
    ${V4L2_DIR}/MediaControl.cpp
    ${V4L2_DIR}/V4l2DeviceFactory.cpp
    ${V4L2_DIR}/SysCall.cpp
    ${V4L2_DIR}/NodeInfo.cpp
    CACHE INTERNAL "v4l2 sources"
    )

set(V4L2_SRCS
    ${V4L2_SRCS}
    ${MODULES_DIR}/v4l2/v4l2_device.cc
    ${MODULES_DIR}/v4l2/v4l2_subdevice.cc
    ${MODULES_DIR}/v4l2/v4l2_video_node.cc
    CACHE INTERNAL "v4l2 sources"
    )

=== debian/changelog ===
ipu7-camera-hal (0~git202501150539.431ff3f-1~ubuntu24.04.1) noble; urgency=medium

  [ Shih-Yuan Lee (FourDollars) ]
  * Initial release.

  [ Commercial Engineering ]
  * Auto build.

 -- Commercial Engineering <commercial-engineering@canonical.com>  Wed, 12 Feb 2025 07:53:50 +0000

=== debian/control ===
Source: ipu7-camera-hal
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 libdrm-dev,
 libexpat-dev,
 libipu7x-dev (>= 0~git202409300310.ef8ead3~),
 libipu75xa-dev (>= 0~git202409300310.ef8ead3~),
 libjsoncpp-dev,
 pkg-config,
 dh-modaliases,
Standards-Version: 4.5.0
Maintainer: Commercial Engineering <commercial-engineering@canonical.com>
Vcs-Browser: https://github.com/intel/ipu7-camera-hal
Vcs-Git: https://github.com/intel/ipu7-camera-hal.git

Package: libcamhal-ipu75xa-common
Architecture: all
Depends:
 ${misc:Depends},
Description: Profiles/settings for MIPI camera through Intel IPU7 PTL - common files
 This package contains default camera settings on Intel Panther Lake platform.

Package: libcamhal-ipu7x-common
Architecture: all
Depends:
 ${misc:Depends},
Description: Profiles/settings for MIPI camera through Intel IPU7 LNL - common files
 This package contains default camera settings on Intel Lunar Lake platform.

Package: libcamhal-ipu7-common
Architecture: all
Depends:
 ${misc:Depends},
 libcamhal-ipu7x-common (= ${binary:Version}),
Description: Transitional package for libcamhal-ipu7x-common
 This is a transitional package for libcamhal-ipu7x-common, and can be
 safely removed after the installation is complete.

Package: libcamhal-ipu75xa
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal-ipu75xa-common (= ${binary:Version}),
 libcamhal0 (>= 0~git202408150943.6991325~~),
XB-Modaliases: ${modaliases}
Description: Dynamic loading plugin for MIPI camera through Intel IPU7 PTL
 This package contains the main runtime library on Intel Panther Lake platform.

Package: libcamhal-ipu75xa0
Architecture: all
Depends:
 ${misc:Depends},
 libcamhal-ipu75xa (= ${binary:Version}),
Description: Transitional package for libcamhal-ipu75xa
 This is a transitional package for libcamhal-ipu75xa, and can be
 safely removed after the installation is complete.

Package: libcamhal-ipu7x
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcamhal-ipu7x-common (= ${binary:Version}),
 libcamhal0 (>= 0~git202408150943.6991325~~),
XB-Modaliases: ${modaliases}
Description: Dynamic loading plugin for MIPI camera through Intel IPU7 LNL
 This package contains the main runtime library on Intel Lunar Lake platform.

Package: libcamhal-ipu7x0
Architecture: all
Depends:
 ${misc:Depends},
 libcamhal-ipu7x (= ${binary:Version}),
Description: Transitional package for libcamhal-ipu7x
 This is a transitional package for libcamhal-ipu7x, and can be
 safely removed after the installation is complete.

Package: libcamhal-ipu7-0
Architecture: all
Depends:
 ${misc:Depends},
 libcamhal-ipu7x (= ${binary:Version}),
Description: Transitional package for libcamhal-ipu7x
 This is a transitional package for libcamhal-ipu7x, and can be
 safely removed after the installation is complete.

Package: libcamhal-ipu75xa-dev
Architecture: any
Depends:
 ${misc:Depends},
 libcamhal-ipu75xa (= ${binary:Version}),
Description: Plugin static library for MIPI camera through Intel IPU7 PTL - development kit
 This package contains development files for libcamhal-ipu75xa on Intel Panther
 Lake platform.

Package: libcamhal-ipu7x-dev
Architecture: any
Depends:
 ${misc:Depends},
 libcamhal-ipu7x (= ${binary:Version}),
Description: Plugin static library for MIPI camera through Intel IPU7 LNL - development kit
 This package contains development files for libcamhal-ipu7x on Intel Lunar
 Lake platform.

Package: libcamhal-ipu7-dev
Architecture: all
Depends:
 ${misc:Depends},
 libcamhal-ipu7x-dev (= ${binary:Version}),
Description: Transitional package for libcamhal-ipu7x-dev
 This is a transitional package for libcamhal-ipu7x-dev, and can be
 safely removed after the installation is complete.

=== debian/rules ===
--- 
+++ 
@@ -31,7 +31,7 @@
 	find config/linux -name *.bin -or -name *.aiqb | sed 's,config/linux,debian,g'| sed 's,ipu7x,ipu7x/etc/camera/ipu7x,g' | sed 's,ipu75xa,ipu75xa/etc/camera/ipu75xa,g' | sort > debian/source/include-binaries
 	for ipu_ver in $(targets); do \
 	  sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
-	      debian/libcamhal-$${ipu_ver}0.install.in > debian/libcamhal-$${ipu_ver}0.install; \
+	      debian/libcamhal-$${ipu_ver}.install.in > debian/libcamhal-$${ipu_ver}.install; \
 	  sed "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
 	      debian/libcamhal-$${ipu_ver}-dev.install.in > debian/libcamhal-$${ipu_ver}-dev.install; \
 	  dh_auto_install --builddirectory=build/$${ipu_ver} --destdir=debian/$${ipu_ver}; \
